// Copyright © 2020 Vaqtincha

/**■■■■■■■■■■■■■■■■■■■■■■■■■■■■ CONFIG START ■■■■■■■■■■■■■■■■■■■■■■■■■■■■*/

// #define DEBUG_WEAPON
#define CLIENT_DEATHMSG_HUD

new const VIEW_MODEL[] =		"models/csgo_ports/cz75/v_cz75.mdl"
new const WEAPON_MODEL[] =		"models/csgo_ports/cz75/p_cz75.mdl"
new const WORLD_MODEL[] =		"models/csgo_ports/cz75/w_cz75.mdl"

new const WEAPON_FIRE_SOUND[] = "weapons/csgo_ports/cz75/cz75-1.wav"

new const WEAPON_BASE_CLASS[] = "weapon_p228"

new const WEAPON_CUSTOM_CLASS[] = "weapon_cz75"

new const BRASS_MODEL[] = "models/pshell.mdl"
new Float:BRASS_VECTORS[3] = { -3.0, 16.0, 4.0 }


const WEAPON_PRICE						= 1000
const WEAPON_MAX_CLIP 					= 12
const WEAPON_MAX_AMMO 					= 12
const WEAPON_BULLET_PENETRATION 		= 2
const WEAPON_DAMAGE 					= 45 // 33
const Float:DAMAGE_RANGE_MODIFER		= 0.95
const Float:WEAPON_RECOIL 				= 0.8
const Float:WEAPON_ATTACK_DELAY 		= 0.25
const Float:MAX_SHOT_DISTANCE			= 8192.0
const Float:WEAPON_MAX_SPEED			= 240.0
// Mark the time of this shot and determine the accuracy modifier based on the last shot fired...
const Float:WEAPON_ACCURACY_MODIFIER 	= 0.3
const Float:WEAPON_ACCURACY_MIN			= 0.7
const Float:WEAPON_ACCURACY_MAX			= 0.9

										// jump, move, duck, normal
new const Float:WEAPON_SPREAD[] = 		{ 0.5, 0.185, 0.075, 0.1 }

// for example: default DEAGLE 			{ 1.5, 0.25, 0.115, 0.13 }

/**■■■■■■■■■■■■■■■■■■■■■■■■■■■■■ CONFIG END ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■*/

const WEAPON_CUSTOM_INDEX = 413978261

#define PL_VERSION 		"1.0"


#include <amxmodx>
#include <reapi>
#include <hamsandwich>
#include <fakemeta>
#include <engine>
#include <xs>

enum sequence_s
{
	AnimNum,
	Float:fAnimTime
}

enum _:CZ75_ANIM
{
	IDLE_1,
	IDLE_2,
	DRAW_1,
	DRAW_2,
	SHOOT_1,
	SHOOT_2,
	SHOOT_EMPTY_1,
	SHOOT_EMPTY_2,
	RELOAD_1,
	RELOAD_2,
	INSPECT_1,
	INSPECT_2
}

enum
{
	P228_IDLE,
	P228_SHOOT1,
	P228_SHOOT2,
	P228_SHOOT3,
	P228_SHOOT_EMPTY,
	P228_RELOAD,
	P228_DRAW
}


enum any:model_s
{
	SeqName[32],
	SeqNum,
	Frames,
	Float:FPS
}

const MAX_VIEW_MODEL_SEQUENCES = 20

enum
{
	FIRE_ON_JUMP,
	FIRE_ON_MOVE,
	FIRE_ON_DUCK,
	FIRE_ON_NORMAL
}

enum any:brass_e
{
	brass_up,
	brass_forward,
	brass_right
}	

#define IsCustomWeapon(%1) 			(get_entvar(%1, var_impulse) == WEAPON_CUSTOM_INDEX)
#define IsPlayer(%1)				(1 <= %1 <= g_iMaxPlayers)

#if !defined write_coord_f
	#define write_coord_f(%1)			engfunc(EngFunc_WriteCoord, %1)
#endif

#if !defined write_angle_f
	#define write_angle_f(%1)			engfunc(EngFunc_WriteAngle, %1)
#endif

new g_aSequenceData[CZ75_ANIM][sequence_s]
new bool:g_bShowBackClip[MAX_CLIENTS + 1]

new g_iGunshotSmoke, g_iGunshotDecal = -1, g_iShellId
new HookChain:g_hBuyWeaponByWeaponID, HamHook:g_hGetItemInfo
new mp_buytime, g_iMaxPlayers
// def weapon values
new any:WEAPON_BASE_INDEX, WEAPON_BASE_AMMO_INDEX, WEAPON_BASE_AMMO_MAX, WEAPON_BASE_SLOT, WEAPON_BASE_POSITION

new g_iPrevBuy[MAX_CLIENTS + 1], Float:g_flNextAnimTime[MAX_CLIENTS + 1], bool:g_bActiveItem[MAX_CLIENTS + 1], Float:g_flEjectBrass[MAX_CLIENTS + 1]


public plugin_precache()
{
	precache_model(VIEW_MODEL)
	precache_model(WEAPON_MODEL)
	precache_model(WORLD_MODEL)

	if (ParseSpriteDesc(WEAPON_CUSTOM_CLASS))
	{
		RegisterHam(Ham_Item_AddToPlayer, WEAPON_BASE_CLASS, "CBasePlayerItem_AddToPlayer", .Post = true)
	}

	precache_sound(WEAPON_FIRE_SOUND) // fire sound

	if (get_cvar_num("sv_auto_precache_sound_in_models") != 1) {
		PrecacheModelSounds(VIEW_MODEL)
	}
	
	g_iGunshotSmoke = precache_model("sprites/gunsmoke.spr")
	g_iShellId = precache_model(BRASS_MODEL)
	
	g_hGetItemInfo = RegisterHam(Ham_Item_GetItemInfo, WEAPON_BASE_CLASS, "CBasePlayerItem_GetItemInfo", .Post = true)
}

public plugin_init()
{
	register_plugin("CSGO CZ75", PL_VERSION, "Vaqtincha")

	GetViewModelInfo(VIEW_MODEL)

	register_clcmd("cz75", "ClientCommand_Buy")
	register_clcmd("say /cz75", "ClientCommand_Buy")
	register_clcmd("say /cz", "ClientCommand_Buy")
	register_clcmd("cl_setrebuy", "ClientCommand_ReBuy")
	register_clcmd("cl_rebuy", "ClientCommand_ReBuy")
	
	register_impulse(100, "ClCmd_Impulse")

	register_forward(FM_UpdateClientData, "UpdateClientData", true)

	RegisterHookChain(RG_CWeaponBox_SetModel, "CWeaponBox_SetModel", .post = false)
	RegisterHookChain(RG_CBasePlayer_OnSpawnEquip, "CBasePlayer_OnSpawnEquip", .post = true)
	RegisterHookChain(RG_CBasePlayer_GiveAmmo, "CBasePlayer_GiveAmmo", .post = true)
	RegisterHookChain(RG_BuyWeaponByWeaponID, "BuyWeaponByWeaponID", .post = false)
	DisableHookChain(g_hBuyWeaponByWeaponID = RegisterHookChain(RG_BuyWeaponByWeaponID, "BuyWeaponByWeaponID_P", .post = true))

	
	RegisterHam(Ham_Item_Deploy, WEAPON_BASE_CLASS, "CBasePlayerItem_Deploy", .Post = true)
	RegisterHam(Ham_Item_Holster, WEAPON_BASE_CLASS, "CBasePlayerItem_Holster", .Post = true)
	RegisterHam(Ham_Weapon_PrimaryAttack, WEAPON_BASE_CLASS, "CBasePlayerWeapon_PrimAttack", .Post = false)
	RegisterHam(Ham_Weapon_SecondaryAttack, WEAPON_BASE_CLASS, "CBasePlayerWeapon_SecAttack", .Post = false)
	RegisterHam(Ham_CS_Weapon_SendWeaponAnim, WEAPON_BASE_CLASS, "CBasePlayerWeapon_SendWpnAnim", .Post = true)
	
	mp_buytime = get_cvar_pointer("mp_buytime")
	g_iMaxPlayers = get_maxplayers()

	new const szDecals[][] = { "{shot1", "{shot2", "{shot3", "{shot4", "{shot5" }

	for (new i = 0, iDecal; i < sizeof(szDecals); i++)
	{
		if ((iDecal = engfunc(EngFunc_DecalIndex, szDecals[i])) != -1)
		{
			g_iGunshotDecal = iDecal
			break;
		}
	}
	
	new const szBrushClasses[][] = { "worldspawn", "func_breakable", "func_wall", "func_door",
		"func_door_rotating", "func_plat", "func_rotating" 
	}

	for (new i = 0; i < sizeof(szBrushClasses); i++) {
		RegisterHam(Ham_TraceAttack, szBrushClasses[i], "TraceAttack")
	}
}

public client_putinserver(pPlayer) 
{
	g_iPrevBuy[pPlayer] = 0
	g_flEjectBrass[pPlayer] = g_flNextAnimTime[pPlayer] = 0.0
	g_bActiveItem[pPlayer] = false
}

public ClientCommand_ReBuy(const pPlayer)
{
	if (g_iPrevBuy[pPlayer] == WEAPON_CUSTOM_INDEX) {
		BuyItem(pPlayer, false)
	}
}

public ClientCommand_Buy(const pPlayer)
{
	if (BuyItem(pPlayer))
	{
		g_iPrevBuy[pPlayer] = WEAPON_CUSTOM_INDEX

		new RebuyHandle:hRebuy = get_member(pPlayer, m_rebuyStruct)
		set_rebuy(hRebuy, m_secondaryWeapon, 0)
		set_rebuy(hRebuy, m_secondaryAmmo, 0)
	}

	return PLUGIN_HANDLED
}

public ClCmd_Impulse(const pPlayer)
{
	if (!is_user_alive(pPlayer))
		return PLUGIN_CONTINUE

	if (get_entvar(pPlayer, var_effects) & EF_DIMLIGHT)
		return PLUGIN_CONTINUE
	
	new Float:fCurTime = get_gametime()
	
	if (g_flNextAnimTime[pPlayer] > fCurTime)
		return PLUGIN_CONTINUE

	if (get_member(pPlayer, m_flNextAttack) > 0.1)
		return PLUGIN_CONTINUE
	
	new pActiveItem = get_member(pPlayer, m_pActiveItem)

	if (is_nullent(pActiveItem) || !IsCustomWeapon(pActiveItem))
		return PLUGIN_CONTINUE

	new AnimType = g_bShowBackClip[pPlayer] ? INSPECT_1 : INSPECT_2
		
	new NewAnim = g_aSequenceData[AnimType][AnimNum]
	new Float:fTime = g_aSequenceData[AnimType][fAnimTime]
		
	if (fTime > 0.0 && NewAnim != -1)
	{
		SendWeaponAnim(pPlayer, NewAnim)
		set_member(pActiveItem, m_Weapon_flTimeWeaponIdle, fTime + 0.1)
	
		g_flNextAnimTime[pPlayer] = fCurTime + fTime
	}

	return PLUGIN_HANDLED
}

public BuyWeaponByWeaponID_P(const pPlayer, const WeaponIdType:iId)
{
	DisableHookChain(g_hBuyWeaponByWeaponID)

	if (GetHookChainReturn(ATYPE_INTEGER) <= 0) { // failed
		SetFakeWeaponId(pPlayer, WEAPON_BASE_INDEX)
	}
}

public BuyWeaponByWeaponID(const pPlayer, const WeaponIdType:iId)
{
	if (iId == WEAPON_BASE_INDEX && !get_member(pPlayer, m_bIsInRebuy))
	{
		EnableHookChain(g_hBuyWeaponByWeaponID)
		SetFakeWeaponId(pPlayer, WEAPON_SHIELDGUN)
		g_iPrevBuy[pPlayer] = 0
	}
}

public CBasePlayer_GiveAmmo(const pPlayer, iAmount, szName[], iMax)
{
	if (iAmount > 0 && iMax == WEAPON_MAX_AMMO && GetHookChainReturn(ATYPE_INTEGER) == WEAPON_BASE_AMMO_INDEX)
	{
		SetWeaponState(pPlayer)
	}
}

public CBasePlayer_OnSpawnEquip(const pPlayer, bool:addDefault, bool:equipGame)
{
	if (get_member(pPlayer, m_bNotKilled)) {
		SetWeaponState(pPlayer)
	}
}

public UpdateClientData(const pPlayer, const sendweapons, const CD_Handle)
{
	if (g_bActiveItem[pPlayer]/*  && sendweapons */) 
	{	
		static Float:fGameTime
		fGameTime = get_gametime()
		
		set_cd(CD_Handle, CD_flNextAttack, fGameTime + 0.001)

		if (g_flEjectBrass[pPlayer] != 0.0 && fGameTime > g_flEjectBrass[pPlayer])
		{
			EjectBrassLate(pPlayer, g_iShellId, BRASS_VECTORS)
			g_flEjectBrass[pPlayer] = 0.0
		}
	}
}

public TraceAttack(const pEntity, const pevAttacker, const Float:damage, const Float:direction[3], const ptr, const damage_bits)
{
	if (!IsPlayer(pevAttacker) || !g_bActiveItem[pevAttacker])
		return

	static Float:vecEnd[3], Float:vecPlaneNormal[3]

	get_tr2(ptr, TR_vecEndPos, vecEnd)
	get_tr2(ptr, TR_vecPlaneNormal, vecPlaneNormal)

	UTIL_GunshotDecalTrace(get_tr2(ptr, TR_pHit), vecEnd, vecPlaneNormal)
}

public CWeaponBox_SetModel(const pWeaponBox, const szModel[])
{
	if (pWeaponBox <= 0)
		return

	new pWeapon = GetWeaponBoxWeapon(pWeaponBox)
	if (pWeapon > 0 && IsCustomWeapon(pWeapon))
	{
		if (get_member(pWeapon, m_iId) == WEAPON_SHIELDGUN) { // back to real weaponID
			set_member(pWeapon, m_iId, WEAPON_BASE_INDEX)
		}

		SetHookChainArg(2, ATYPE_STRING, WORLD_MODEL)
	}
}


public CBasePlayerWeapon_SendWpnAnim(const pWeapon, const iAnim, const skiplocal)
{
	if (pWeapon <= 0 || !IsCustomWeapon(pWeapon))
		return

	new NewAnim = -1, AnimType, Float:fTime, pPlayer = get_member(pWeapon, m_pPlayer)

	if (pPlayer <= 0)
		return
	
	switch (iAnim)
	{
		case P228_IDLE:
		{
			AnimType = g_bShowBackClip[pPlayer] ? IDLE_1 : IDLE_2
			NewAnim = g_aSequenceData[AnimType][AnimNum]
			fTime = g_aSequenceData[AnimType][fAnimTime]
		}
		// case P228_SHOOT1, P228_SHOOT2, P228_SHOOT3:
		// case P228_SHOOT_EMPTY:
		case P228_RELOAD:
		{
			AnimType = g_bShowBackClip[pPlayer] ? RELOAD_1 : RELOAD_2
			NewAnim = g_aSequenceData[AnimType][AnimNum]
			fTime = g_aSequenceData[AnimType][fAnimTime]

			if (g_bShowBackClip[pPlayer]) {
				g_bShowBackClip[pPlayer] = false
			}
		}
		case P228_DRAW: 
		{
			new iMaxAmmo = get_member(pPlayer, m_rgAmmo, get_member(pWeapon, m_Weapon_iPrimaryAmmoType))

			g_bShowBackClip[pPlayer] = bool:(iMaxAmmo >= WEAPON_MAX_AMMO)
		
			AnimType = g_bShowBackClip[pPlayer] ? DRAW_1 : DRAW_2
			NewAnim = g_aSequenceData[AnimType][AnimNum]
			fTime = g_aSequenceData[AnimType][fAnimTime]
		}
	}

	if (fTime > 0.0 && NewAnim != -1)
	{
		SendWeaponAnim(pPlayer, NewAnim)
		set_member(pWeapon, m_Weapon_flTimeWeaponIdle, fTime + 0.1)
	}
}

public CBasePlayerItem_GetItemInfo(const pItem, const iItemInfo) 
{
	if (iItemInfo)
	{
		WEAPON_BASE_INDEX = GetHamItemInfo(iItemInfo, Ham_ItemInfo_iId)
		WEAPON_BASE_AMMO_INDEX = rg_get_weapon_info(WEAPON_BASE_INDEX, WI_AMMO_TYPE)
		WEAPON_BASE_AMMO_MAX = GetHamItemInfo(iItemInfo, Ham_ItemInfo_iMaxAmmo1)
		WEAPON_BASE_SLOT = GetHamItemInfo(iItemInfo, Ham_ItemInfo_iSlot)
		WEAPON_BASE_POSITION = GetHamItemInfo(iItemInfo, Ham_ItemInfo_iPosition)
	}

	DisableHamForward(g_hGetItemInfo)
}

public CBasePlayerItem_AddToPlayer(const pItem, const pPlayer)  
{
	if (pItem <= 0 || !is_user_alive(pPlayer))
		return

	if (IsCustomWeapon(pItem))
		SendWeaponList(pPlayer, WEAPON_CUSTOM_CLASS, WEAPON_MAX_AMMO)
	else
		SendWeaponList(pPlayer, WEAPON_BASE_CLASS, WEAPON_BASE_AMMO_MAX)
}

public CBasePlayerItem_Deploy(const pItem)
{
	if (pItem <= 0 || !IsCustomWeapon(pItem))
		return

	new pPlayer = get_member(pItem, m_pPlayer)

	if (IsPlayer(pPlayer))
	{
		set_member(pItem, m_Weapon_fMaxSpeed, WEAPON_MAX_SPEED)
		set_member(pItem, m_Weapon_flAccuracy, WEAPON_ACCURACY_MAX)

		set_entvar(pPlayer, var_viewmodel, VIEW_MODEL)
		set_entvar(pPlayer, var_weaponmodel, WEAPON_MODEL)

		g_flNextAnimTime[pPlayer] = get_gametime() + 0.3
		g_bActiveItem[pPlayer] = true
		
		set_member(pPlayer, m_flNextAttack, g_aSequenceData[DRAW_1][fAnimTime] - 0.2)
		
		if (get_member(pPlayer, m_bOwnsShield))
		{
			set_entvar(pPlayer, var_gamestate, 1)
			set_entvar(pItem, var_weapons, 1)
			set_member(pPlayer, m_szAnimExtention, "onehanded")
		}
	}
}

public CBasePlayerItem_Holster(const pItem)
{
	if (pItem <= 0 /* || !IsCustomWeapon(pItem) */)
		return
	
	new pPlayer = get_member(pItem, m_pPlayer)
		
	if (IsPlayer(pPlayer))
	{
		g_bActiveItem[pPlayer] = false
		g_flEjectBrass[pPlayer] = g_flNextAnimTime[pPlayer] = 0.0

		if (get_entvar(pItem, var_weapons) > 0) 
		{
			set_entvar(pPlayer, var_gamestate, 0)
			set_entvar(pItem, var_weapons, 0)
		}
	}
}


public CBasePlayerWeapon_SecAttack(const pWeapon)
{
	return (pWeapon > 0 && IsCustomWeapon(pWeapon)) ? HAM_SUPERCEDE : HAM_IGNORED
}

public CBasePlayerWeapon_PrimAttack(const pWeapon)
{
	if (pWeapon <= 0 || !IsCustomWeapon(pWeapon))
		return HAM_IGNORED
	
	static pPlayer, Float:flSpread, bitFlags

	if ((pPlayer = get_member(pWeapon, m_pPlayer)) <= 0)
		return HAM_IGNORED

	// if (get_member_game(m_bFreezePeriod) || get_member(pPlayer, m_bIsDefusing))
		// return HAM_IGNORED

	bitFlags = get_entvar(pPlayer, var_flags)
	
	if (!(bitFlags & FL_ONGROUND)) {
		flSpread = Float:WEAPON_SPREAD[FIRE_ON_JUMP]
	}
	else if (Length2D(pPlayer) > 0.0) {
		flSpread = Float:WEAPON_SPREAD[FIRE_ON_MOVE]
	}
	else if (bitFlags & FL_DUCKING) {
		flSpread = Float:WEAPON_SPREAD[FIRE_ON_DUCK]
	}
	else {
		flSpread = Float:WEAPON_SPREAD[FIRE_ON_NORMAL]
	}

	return WeaponFire(pWeapon, pPlayer, flSpread, WEAPON_ATTACK_DELAY, g_bShowBackClip[pPlayer])
}


WeaponFire(const pWeapon, const pPlayer, Float:flSpread, Float:flCycleTime, bool:isSecAttack = false)
{
	static iClip, Float:flAccuracy, Anim, Float:flLastFire, Float:flGameTime, Float:vecPunchAngle[3]

	flCycleTime -= 0.075
	
	if ((iClip = get_member(pWeapon, m_Weapon_iClip)) <= 0) {
		return HAM_IGNORED
	}

	flGameTime = get_gametime()

	if ((flLastFire = get_member(pWeapon, m_Weapon_flLastFire)) != 0.0)
	{
		flAccuracy = get_member(pWeapon, m_Weapon_flAccuracy)

		// Mark the time of this shot and determine the accuracy modifier based on the last shot fired...
		flAccuracy -= ((WEAPON_ATTACK_DELAY - (flGameTime - flLastFire)) * WEAPON_ACCURACY_MODIFIER)
	
		flAccuracy = floatclamp(flAccuracy, WEAPON_ACCURACY_MIN, WEAPON_ACCURACY_MAX)

		set_member(pWeapon, m_Weapon_flAccuracy, flAccuracy)
	}
	else
	{
		flAccuracy = WEAPON_ACCURACY_MAX
	}
	
	--iClip
#if defined DEBUG_WEAPON
	client_print(pPlayer, print_chat, "flSpread %f flAccuracy %f", (1.0 - flAccuracy) * flSpread, flAccuracy)
#else
	set_member(pWeapon, m_Weapon_iClip, iClip)
#endif

	set_member(pWeapon, m_Weapon_flLastFire, flGameTime)
	set_entvar(pPlayer, var_effects, get_entvar(pPlayer, var_effects) | EF_MUZZLEFLASH)

	rg_set_animation(pPlayer, PLAYER_ATTACK1)
	get_entvar(pPlayer, var_punchangle, vecPunchAngle)

	rg_fire_bullets3(pPlayer, pPlayer, GetGunPosition(pPlayer), GetAimingVector(pPlayer, vecPunchAngle), (1.0 - flAccuracy) * flSpread, MAX_SHOT_DISTANCE, 
		WEAPON_BULLET_PENETRATION, BULLET_PLAYER_357SIG, WEAPON_DAMAGE, DAMAGE_RANGE_MODIFER, false, get_member(pPlayer, random_seed)
	)
	
	Anim = isSecAttack ? g_aSequenceData[SHOOT_1][AnimNum] : g_aSequenceData[SHOOT_2][AnimNum]
	
	SendWeaponAnim(pPlayer, Anim)
	
	vecPunchAngle[0] -= WEAPON_RECOIL
	set_member(pWeapon, m_Weapon_flNextPrimaryAttack, flCycleTime)

	emit_sound(pPlayer, CHAN_WEAPON, WEAPON_FIRE_SOUND, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

	set_member(pWeapon, m_Weapon_flTimeWeaponIdle, flCycleTime + 1.5)

	set_entvar(pPlayer, var_punchangle, vecPunchAngle)

	g_flNextAnimTime[pPlayer] = flGameTime + 0.3
	g_flEjectBrass[pPlayer] = flGameTime + 0.1
	
	return HAM_SUPERCEDE
}


SetWeaponState(pPlayer, pItem = NULLENT)
{
	if (pItem <= 0)
	{
		pItem = GetCustomItem(pPlayer)
	}

	if (pItem != NULLENT)
	{
		new iMaxAmmo = get_member(pPlayer, m_rgAmmo, get_member(pItem, m_Weapon_iPrimaryAmmoType))

		g_bShowBackClip[pPlayer] = bool:(iMaxAmmo >= WEAPON_MAX_AMMO)
		
		if (pItem == get_member(pPlayer, m_pActiveItem))
		{
			rg_switch_weapon(pPlayer, pItem)
		}
	}
}


EjectBrassLate(const pPlayer, const iszModel, Float:vecBrass[brass_e])
{
	static Float:vecPunchAngle[3], Float:vecOutput[3], Float:vecVelocity[3], Float:vecForward[3],
		Float:vecAngles[3], Float:vecOrigin[3], Float:vecVAngle[3], Float:vecViewOfs[3],
		Float:vecShellVelocity[3], Float:vecShellOrigin[3], Float:vecUp[3], Float:vecRight[3]
	
	get_entvar(pPlayer, var_v_angle, vecVAngle)
	get_entvar(pPlayer, var_punchangle, vecPunchAngle)
	xs_vec_add(vecVAngle, vecPunchAngle, vecOutput)
	engfunc(EngFunc_MakeVectors, vecOutput)	

	get_entvar(pPlayer, var_velocity, vecVelocity)
	get_entvar(pPlayer, var_view_ofs, vecViewOfs)
	get_entvar(pPlayer, var_angles, vecAngles)
	get_entvar(pPlayer, var_origin, vecOrigin)
	
	global_get(glb_v_right, vecRight)
	global_get(glb_v_up, vecUp)
	global_get(glb_v_forward, vecForward)

	for (new i = 0; i < 3; i++ )
	{
		// vecShellOrigin[i] = vecOrigin[i] + vecViewOfs[i] + (vecUp[i] * -3.0) + (vecForward[i] * 16.0) + (vecRight[i] * 4.0)
		vecShellOrigin[i] = vecOrigin[i] + vecViewOfs[i] + (vecUp[i] * Float:vecBrass[brass_up]) + (vecForward[i] * Float:vecBrass[brass_forward]) + (vecRight[i] * Float:vecBrass[brass_right])
		vecShellVelocity[i] = vecVelocity[i] + (vecRight[i] * random_float(50.0, 70.0)) + (vecUp[i] * random_float(100.0, 150.0)) + (vecForward[i] * 25.0)
		// vecOutput[i] = vecRight[i] * -9.0
	}

	EjectBrass(pPlayer, vecShellOrigin, vecShellVelocity, vecOutput, vecAngles[1], iszModel)
}

SendWeaponList(const pPlayer, const szName[], const iMaxAmmo)
{
	static iMsgIdWeaponList

	if (iMsgIdWeaponList > 0 || (iMsgIdWeaponList = get_user_msgid("WeaponList")) > 0)
	{
		message_begin(MSG_ONE, iMsgIdWeaponList, .player = pPlayer)
		write_string(szName)
		write_byte(WEAPON_BASE_AMMO_INDEX) // iPrimaryAmmoType
		write_byte(iMaxAmmo) // iMaxAmmo1
		write_byte(-1) // iSecondaryAmmoType
		write_byte(-1) // iMaxAmmo2
		write_byte(WEAPON_BASE_SLOT) 	// iSlot
		write_byte(WEAPON_BASE_POSITION) 	// iPosition
		write_byte(WEAPON_BASE_INDEX) 	// iId
		write_byte(0) 	// iFlags
		message_end()
	}
}

SetFakeWeaponId(const pPlayer, const WeaponIdType:iId)
{
	new pItem = GetCustomItem(pPlayer)
	if (pItem > 0) {
		set_member(pItem, m_iId, iId)
	}
}

GetCustomItem(const pPlayer)
{
	for (new InventorySlotType:iSlot = PRIMARY_WEAPON_SLOT, pItem; iSlot <= C4_SLOT; iSlot++)
	{
		if (iSlot == KNIFE_SLOT)
			continue

		pItem = get_member(pPlayer, m_rgpPlayerItems, iSlot)

		while (!is_nullent(pItem))
		{
			if (get_entvar(pItem, var_impulse) == WEAPON_CUSTOM_INDEX) 
			{
				return pItem
			}
			
			pItem = get_member(pItem, m_pNext)
		}
	}
	
	return NULLENT
}

bool:BuyItem(const pPlayer, bool:bPrint = true) 
{
	if (!CanPlayerBuy(pPlayer, bPrint))
		return false
	
	if (GiveItem(pPlayer) > 0)
	{
		rg_add_account(pPlayer, -WEAPON_PRICE)
		return true
	}
	
	return false
}

GiveItem(const pPlayer)
{
	new pWeapon = rg_give_custom_item(pPlayer, WEAPON_BASE_CLASS, GT_DROP_AND_REPLACE, WEAPON_CUSTOM_INDEX)
	
	if (!is_nullent(pWeapon))
	{
		rg_set_iteminfo(pWeapon, ItemInfo_iMaxClip, WEAPON_MAX_CLIP)
		rg_set_iteminfo(pWeapon, ItemInfo_iMaxAmmo1, WEAPON_MAX_AMMO)
		// rg_set_iteminfo(pWeapon, ItemInfo_iFlags, ITEM_FLAG_EXHAUSTIBLE)
#if defined CLIENT_DEATHMSG_HUD
		rg_set_iteminfo(pWeapon, ItemInfo_pszName, WEAPON_CUSTOM_CLASS)
#endif
		set_member(pWeapon, m_Weapon_iClip, WEAPON_MAX_CLIP)
		// set_member(pWeapon, m_Weapon_bHasSecondaryAttack, true)
		set_entvar(pWeapon, var_classname, WEAPON_CUSTOM_CLASS)
		
		set_member(pWeapon, m_Weapon_iShellId, g_iShellId)
		
		if (rg_get_user_bpammo(pPlayer, WEAPON_BASE_INDEX) > WEAPON_MAX_AMMO)
		{
			rg_set_user_bpammo(pPlayer, WEAPON_BASE_INDEX, WEAPON_MAX_AMMO)
		}
		else
		{
			new pszAmmo1[32]
			rg_get_iteminfo(pWeapon, ItemInfo_pszAmmo1, pszAmmo1, charsmax(pszAmmo1))
			ExecuteHam(Ham_GiveAmmo, pPlayer, WEAPON_MAX_AMMO, pszAmmo1, WEAPON_MAX_AMMO)
		}
		
		return pWeapon
	}
	
	return NULLENT
}

bool:CanPlayerBuy(const pPlayer, bool:bPrint = true)
{
	if (!is_user_alive(pPlayer))
		return false

	new iSignals[UnifiedSignals]
	get_member(pPlayer, m_signals, iSignals)

	if (!(iSignals[US_State] & any:SIGNAL_BUY))
		return false
	
	new Float:flBuyTime = get_pcvar_float(mp_buytime)

	if (flBuyTime == 0.0)
		return false

	if (flBuyTime != -1.0 && (get_gametime() - Float:get_member_game(m_fRoundStartTime) > (flBuyTime * 60)))
	{
		client_print(pPlayer, print_center, "%0.f seconds have passed.^rYou can't buy anything now!", flBuyTime * 60)
		return false
	}
	
	if (GetCustomItem(pPlayer) > 0)
	{
		if (bPrint) {
			client_print(pPlayer, print_center, "You already own that weapon.")
		}

		return false
	}
	
	if (get_member(pPlayer, m_iAccount) < WEAPON_PRICE)
	{
		client_print(pPlayer, print_center, "You have insufficient funds!")
		BlinkAccount(pPlayer)
		return false
	}
	
	return true
}

SendWeaponAnim(const pPlayer, const iAnimNum, bool:bSkipLocal = false)
{
	new aPlayers[32], iCount, pClient
	get_players(aPlayers, iCount, "ch") // skip bot's & hltv
	
	for (--iCount; iCount >= 0; iCount--)
	{
		pClient = aPlayers[iCount]

		if ((!bSkipLocal && pPlayer == pClient) 
			|| (get_entvar(pClient, var_iuser2) == pPlayer && get_entvar(pClient, var_iuser1) == OBS_IN_EYE))
		{
			set_entvar(pClient, var_weaponanim, iAnimNum)

			message_begin(MSG_ONE, SVC_WEAPONANIM, .player = pClient)
			write_byte(iAnimNum)
			write_byte(0)
			message_end()
		}
	}
}

bool:ParseSpriteDesc(const szClassname[])
{
	new szSpriteDesc[64], szLineData[128], szSprite[32], pFile
	formatex(szSpriteDesc, charsmax(szSpriteDesc), "sprites/%s.txt", szClassname)
	
	if (!(pFile = fopen(szSpriteDesc, "rt")))
		return false

	precache_generic(szSpriteDesc)

	while(!feof(pFile))
	{
		fgets(pFile, szLineData, charsmax(szLineData))
		trim(szLineData)

		if ((parse(szLineData, 1, 0, 1, 0, szSprite, charsmax(szSprite), 1, 0, 1, 0, 1, 0, 1, 0)
			) == 7)
		{
			formatex(szSprite, charsmax(szSprite), "sprites/%s.spr", szSprite)
			precache_generic(szSprite)				
		}
	}

	fclose(pFile)
	return true
}

stock EjectBrass(const pPlayer, Float:vecOrigin[3], Float:vecVelocity[3], Float:vecLeft[3], Float:rotation, const iszModel)
{
	static iMsgIdBrass
	
	if (iMsgIdBrass > 0 || (iMsgIdBrass = get_user_msgid("Brass")) > 0)
	{
		// engfunc(EngFunc_MessageBegin, MSG_PVS, iMsgIdBrass, vecOrigin, 0)
		engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, vecOrigin, 0)
		write_byte(TE_MODEL)
		write_coord_f(vecOrigin[0])
		write_coord_f(vecOrigin[1])
		write_coord_f(vecOrigin[2])	
		// write_coord_f(vecLeft[0])
		// write_coord_f(vecLeft[1])
		// write_coord_f(vecLeft[2])
		write_coord_f(vecVelocity[0])
		write_coord_f(vecVelocity[1])
		write_coord_f(vecVelocity[2])
		write_angle_f(rotation)
		write_short(iszModel)
		write_byte(1)
		write_byte(25)
		// write_byte(pPlayer)
		message_end()
		
		#pragma unused vecLeft, pPlayer
	}
}

stock UTIL_GunshotDecalTrace(const pHit, const Float:vecOrigin[3], const Float:vecPlaneNormal[3])
{	
	engfunc(EngFunc_MessageBegin, MSG_PAS, SVC_TEMPENTITY, vecOrigin, 0)
	write_byte(TE_EXPLOSION)
	write_coord_f(vecOrigin[0] + (3.0 * vecPlaneNormal[0]))
	write_coord_f(vecOrigin[1] + (3.0 * vecPlaneNormal[1]))
	write_coord_f(vecOrigin[2] - 10.0 + (4.0 * vecPlaneNormal[1]))
	write_short(g_iGunshotSmoke)
	write_byte(2)
	write_byte(40)
	write_byte(TE_EXPLFLAG_NODLIGHTS | TE_EXPLFLAG_NOSOUND | TE_EXPLFLAG_NOPARTICLES)
	message_end()
	
	if (g_iGunshotDecal != -1)
	{
		// message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		engfunc(EngFunc_MessageBegin, MSG_PAS, SVC_TEMPENTITY, vecOrigin, 0)
		write_byte(TE_GUNSHOTDECAL)
		write_coord_f(vecOrigin[0])
		write_coord_f(vecOrigin[1])
		write_coord_f(vecOrigin[2])
		write_short(pHit > 0 ? pHit : 0)
		write_byte(g_iGunshotDecal)
		message_end()
	}
}

stock GetWeaponBoxWeapon(const pWeaponBox)
{
	for (new pWeapon, InventorySlotType:i = PRIMARY_WEAPON_SLOT; i <= C4_SLOT; i++)
	{
		if (i != KNIFE_SLOT && !is_nullent((pWeapon = get_member(pWeaponBox, m_WeaponBox_rgpPlayerItems, i)))) {
			return pWeapon
		}
	}

	return NULLENT
}

stock Float:GetAimingVector(const pPlayer, const Float:vecPunchAngle[3])
{
	new Float:vecOutput[3]
	get_entvar(pPlayer, var_v_angle, vecOutput)
	xs_vec_add(vecOutput, vecPunchAngle, vecOutput)
	engfunc(EngFunc_MakeVectors, vecOutput)
	global_get(glb_v_forward, vecOutput)
	
	return vecOutput
}

stock Float:GetGunPosition(const pPlayer)
{
	new Float:vecOrigin[3], Float:vecViewOfs[3], Float:vecOutput[3]
	get_entvar(pPlayer, var_origin, vecOrigin)
	get_entvar(pPlayer, var_view_ofs, vecViewOfs)
	xs_vec_add(vecOrigin, vecViewOfs, vecOutput)
	
	return vecOutput
}

stock Float:Length2D(const pPlayer) // Arkshine
{
	new Float:vecVelocity[3]
	get_entvar(pPlayer, var_velocity, vecVelocity)
	return (floatsqroot(vecVelocity[0] * vecVelocity[0] + vecVelocity[1] * vecVelocity[1]))
}

GetViewModelInfo(const szModel[])
{
	new iTotalSequences, aSeqInfo[MAX_VIEW_MODEL_SEQUENCES][model_s]

	if ((iTotalSequences = GetModelInfo(szModel, aSeqInfo)) > 0)
	{
		for (new i = 0; i < iTotalSequences; i++)
		{
			// server_print("[ANIM INFO] SeqName %s | AnimId %i | Time %f", aSeqInfo[i][SeqName], i, (aSeqInfo[i][Frames] / aSeqInfo[i][FPS]))

			g_aSequenceData[i][AnimNum] = i
			g_aSequenceData[i][fAnimTime] = _:(aSeqInfo[i][Frames] / aSeqInfo[i][FPS])
		}
	}
}

stock GetModelInfo(const szModel[], SeqInfo[MAX_VIEW_MODEL_SEQUENCES][model_s])
{
	new pFile

	if (!(pFile = fopen(szModel, "rb")))
		return 0

	new szLabel[32], iSeqIndex, Float:flFPS, iFrames, iNumSeq

	fseek(pFile, 164, SEEK_SET)
	fread(pFile, iNumSeq, BLOCK_INT)
	fread(pFile, iSeqIndex, BLOCK_INT)

	for (new i = 0; i < iNumSeq; i++)
	{
		fseek(pFile, iSeqIndex + 176 * i, SEEK_SET)
		fread_blocks(pFile, szLabel, 32, BLOCK_CHAR)

		if (!szLabel[0])
			continue
	
		fread(pFile, _:flFPS, BLOCK_INT)
		fseek(pFile, 20, SEEK_CUR)
		fread(pFile, iFrames, BLOCK_INT)
		
		copy(SeqInfo[i][SeqName], 31, szLabel)
		SeqInfo[i][SeqNum] = i
		SeqInfo[i][Frames] = iFrames
		SeqInfo[i][FPS] = _:flFPS

		// server_print("[MODEL INFO] Name %s animId %i Time %f", szLabel, i, _:(iFrames / flFPS))

		if (i > MAX_VIEW_MODEL_SEQUENCES)
			break
	}

	fclose(pFile)
	return iNumSeq
}

stock BlinkAccount(const pPlayer, const iNumBlinks = 2)
{
	static iMsgIdBlinkAcct
	if (iMsgIdBlinkAcct || (iMsgIdBlinkAcct = get_user_msgid("BlinkAcct")))
	{
		message_begin(MSG_ONE_UNRELIABLE, iMsgIdBlinkAcct, .player = pPlayer)
		write_byte(iNumBlinks)
		message_end()
	}
}

stock PrecacheModelSounds(const szModel[])
{
	new pFile

	if (!(pFile = fopen(szModel, "rb")))
		return 0

	new szSoundPath[64], k, i, iNumSeq, iSeqIndex, iEvent, iTotalEvents, iEventIndex
	new iPrecacheTotal
	
	fseek(pFile, 164, SEEK_SET)
	fread(pFile, iNumSeq, BLOCK_INT)
	fread(pFile, iSeqIndex, BLOCK_INT)

	for (i = 0; i < iNumSeq; i++)
	{
		fseek(pFile, iSeqIndex + 48 + 176 * i, SEEK_SET)
		fread(pFile, iTotalEvents, BLOCK_INT)
		fread(pFile, iEventIndex, BLOCK_INT)
		fseek(pFile, iEventIndex + 176 * i, SEEK_SET)

		for (k = 0; k < iTotalEvents; k++)
		{
			fseek(pFile, iEventIndex + 4 + 76 * k, SEEK_SET)
			fread(pFile, iEvent, BLOCK_INT)
			fseek(pFile, 4, SEEK_CUR)

			if (iEvent != 5004)
				continue

			fread_blocks(pFile, szSoundPath, 64, BLOCK_CHAR)

			if (strlen(szSoundPath) > 0)
			{
				strtolower(szSoundPath)
				precache_sound(szSoundPath)
				iPrecacheTotal++
			}

			// server_print("[MODEL INFO] szSoundPath %s", szSoundPath)
		}
	}
  
	fclose(pFile)
	return iPrecacheTotal
}
